Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGLBPID.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGLBPID.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGLBPID.m	(revision 623)
@@ -1,116 +1,116 @@
-DGLBPID	;DJW,TOAD; Health Record Number Identifier ;5/1/07  20:26
-	;;5.3;Registration;**634**;Aug 13, 1993;Build 30
-	; Copyright (C) 2007 WorldVistA
-	;
-	; This program is free software; you can redistribute it and/or modify
-	; it under the terms of the GNU General Public License as published by
-	; the Free Software Foundation; either version 2 of the License, or
-	; (at your option) any later version.
-	;
-	; This program is distributed in the hope that it will be useful,
-	; but WITHOUT ANY WARRANTY; without even the implied warranty of
-	; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-	; GNU General Public License for more details.
-	;
-	; You should have received a copy of the GNU General Public License
-	; along with this program; if not, write to the Free Software
-	; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
-	;'Modified' MAS Patient Look-up Check Cross-References June 1987
-	Q
-	;
-	;
-ID(DFN)	;GFT/VW  IA 10035
-	N ID S ID=$P($G(^DPT(DFN,.36)),U,3) ;PRIMARY LONG ID
-	I ID="" S ID=$$HRN(DFN)
-	I ID="" S ID=$P($G(^DPT(DFN,0)),U,9) I ID]"" S ID=$E(ID,1,3)_"-"_$E(ID,4,5)_"-"_$E(ID,6,99)
-	I ID="" D
-	.N I F I=0:0 S I=$O(^AUPNPAT(DFN,41,I)) Q:'I  I $P($G(^(I,0)),U,5)="" S ID=$P($G(^(0)),U,2) I ID]"" S ID=ID_" ("_$P($G(^DIC(4,I,0)),U,5)_")" Q
-	I ID="" S ID="`"_DFN
-	Q ID
-	;
-	;
-	;
-	;
-HRN(DFN)	;LOOKUP HEALTH RECORD NUMBER
-	I '$G(DUZ(2)) Q ""
-	Q $P($G(^AUPNPAT(DFN,41,DUZ(2),0)),U,2)
-	;
-	;
-GOTIDQ(DFN)	;Do we have the needed number for this guy?
-	N T S T=$$REQID(DFN)
-	I T="SSN" Q $P(^DPT(DFN,0),U,9)]""
-	I T="HRN" Q:'$G(DUZ(2)) 0 Q $P($G(^AUPNPAT(DFN,41,DUZ(2),0)),U,2)]""
-	Q 1
-	;
-	;
-REQID(DFN)	;WHICH IDENTIFICATION FORMAT IS REQUIRED?
-	N TYPE S TYPE=""
-	D:$G(DFN)
-	.S TYPE=+$G(^DPT(DFN,.361)) I TYPE S TYPE=$P($G(^DIC(8,TYPE,0)),U,9) ;try PRIMARY ELIGIBILITY CODE
-	.I TYPE="" S TYPE=+$G(^DPT(DFN,"TYPE")) I TYPE S TYPE=+$G(^DG(391,TYPE,8.2)) ;try patient TYPE
-	I 'TYPE S TYPE=$G(DUZ("AG")),TYPE=$S(TYPE="V":1,1:2) ;or just assume it's HRN if not VA
-	Q $P("SSN^HRN",U,TYPE)
-	;
-	;
-IDCAP()	;Returns 3 characters: " ID" or "SSN"
-	I $G(DUZ("AG"))="E" Q " ID"
-	Q "SSN"
-	;
-	;
-	;
-	;
-	;
-	;
-LONGID	;Called by ^DIC(8.2,2,"LONG") (assumes DA(1) is DFN!)
-	N INSTITU,DFN,DFNID,SSNID,IHSID D GETALL
-	S X=$S($G(IHSID("L"))'?."-":IHSID("L"),$G(SSNID("L"))'?."-":SSNID("L"),$G(DFNID("L"))'?."-":DFNID("L"),1:"")
-	;I X="" W 1/0  ;some LONGID must exist for a patient, else ERROR!
-	Q
-	;
-	;
-SHORTID	;Called by ^DIC(8.2,2,"SHORT") (assumes DA(1) is DFN!)
-	N INSTITU,DFN,DFNID,SSNID,IHSID D GETALL
-	S X=$S($G(IHSID("S"))'?."-":IHSID("S"),$G(SSNID("S"))'?."-":SSNID("S"),$G(DFNID("S"))'?."-":DFNID("S"),1:"")
-	;I X="" W 1/0  ;some SHORTID must exist for a patient, else ERROR!
-	Q
-	;
-	;
-IHSID	;
-	;given INSTITU (current institution #)
-	;get HEALTH RECORD NUMBER (Multiple 4101, 9000001.41) associated
-	;with the institution
-	S IHSID=$P($G(^AUPNPAT(DFN,41,+INSTITU,0)),"^",2)
-	I IHSID'="" D
-	. S IHSID("L")=IHSID ; $J(IHSID,12) ; if we want to zero pad then $TR($J(IHSID("L"),12)," ",0)
-	. S IHSID("S")=$TR(IHSID("L"),$TR(IHSID("L"),9876543210))
-	. S IHSID("S")=$TR($J(IHSID("S"),4)," ",0)
-	. S IHSID("S")=$E(IHSID("S"),$L(IHSID("S"))-3,$L(IHSID("S")))
-	;now return Health Record Number
-	Q
-DFNID	S DFN=DA(1) ; IEN in patient file, with default institution from
-	;kernel system parameters file as prefix.
-	;8989.3,217    DEFAULT INSTITUTION of #8989.3 -- KERNEL SYSTEM PARAMETERS FILE
-	S INSTITU=$P($G(^XTV(8989.3,1,"XUS")),U,17)
-	;150.9  VISIT TRACKING PARAMETERS :: DEFAULT INSTITUTION:
-	I INSTITU="",$P($G(^DIC(150.9,1,0)),U,4)'="" S INSTITU=$P(^(0),U,4)
-	; if we have a medical record number in IHS PATIENT, for this
-	I INSTITU'="",$P($G(^DIC(4,+INSTITU,99)),U)'="" S INSTITU("STA#")=$P(^(99),U)
-	; now put INSTITUtion STATION NUMBER as prefix to DFN as "DFNID"
-	S DFNID("S")="`"_DFN,DFNID("L")=999_"-`"_DFN S:$D(INSTITU("STA#"))#2 DFNID("L")=INSTITU("STA#")_"-`"_DFN
-	Q
-SSNID	;
-	;code scarfed from ^DIC(8.2,1,"LONG") - retrieving the SSN
-	N X
-	S SSNID("L")="" I $D(DFN),$D(^DPT(DFN,0)) S X=$P(^(0),U,9),SSNID("L")=$E(X,1,3)_"-"_$E(X,4,5)_"-"_$E(X,6,10)
-	S SSNID("S")=$P(SSNID("L"),"-",3)
-	Q
-GETALL	;
-	;Utility Subroutine to Getall the variables
-	D DFNID,IHSID,SSNID
-	;K DFNID,SSNID ; kill because HRN is "required"
-	Q
-	;
-ENALL	;RE-INDEX PHONE NUMBER (KIDS POST-INSTALL DG*5.3*634)
-	K ^DPT("AZVWVOE")
-	N DIK S DIK="^DPT(",DIK(1)=".131^251000" D ENALL^DIK
-	Q
+DGLBPID ;DJW,TOAD; Health Record Number Identifier ;5/1/07  20:26
+ ;;5.3;Registration;**634**;Aug 13, 1993;Build 28
+ ; Copyright (C) 2007 WorldVistA
+ ;
+ ; This program is free software; you can redistribute it and/or modify
+ ; it under the terms of the GNU General Public License as published by
+ ; the Free Software Foundation; either version 2 of the License, or
+ ; (at your option) any later version.
+ ;
+ ; This program is distributed in the hope that it will be useful,
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ; GNU General Public License for more details.
+ ;
+ ; You should have received a copy of the GNU General Public License
+ ; along with this program; if not, write to the Free Software
+ ; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ ;'Modified' MAS Patient Look-up Check Cross-References June 1987
+ Q
+ ;
+ ;
+ID(DFN) ;GFT/VW  IA 10035
+ N ID S ID=$P($G(^DPT(DFN,.36)),U,3) ;PRIMARY LONG ID
+ I ID="" S ID=$$HRN(DFN)
+ I ID="" S ID=$P($G(^DPT(DFN,0)),U,9) I ID]"" S ID=$E(ID,1,3)_"-"_$E(ID,4,5)_"-"_$E(ID,6,99)
+ I ID="" D
+ .N I F I=0:0 S I=$O(^AUPNPAT(DFN,41,I)) Q:'I  I $P($G(^(I,0)),U,5)="" S ID=$P($G(^(0)),U,2) I ID]"" S ID=ID_" ("_$P($G(^DIC(4,I,0)),U,5)_")" Q
+ I ID="" S ID="`"_DFN
+ Q ID
+ ;
+ ;
+ ;
+ ;
+HRN(DFN) ;LOOKUP HEALTH RECORD NUMBER
+ I '$G(DUZ(2)) Q ""
+ Q $P($G(^AUPNPAT(DFN,41,DUZ(2),0)),U,2)
+ ;
+ ;
+GOTIDQ(DFN) ;Do we have the needed number for this guy?
+ N T S T=$$REQID(DFN)
+ I T="SSN" Q $P(^DPT(DFN,0),U,9)]""
+ I T="HRN" Q:'$G(DUZ(2)) 0 Q $P($G(^AUPNPAT(DFN,41,DUZ(2),0)),U,2)]""
+ Q 1
+ ;
+ ;
+REQID(DFN) ;WHICH IDENTIFICATION FORMAT IS REQUIRED?
+ N TYPE S TYPE=""
+ D:$G(DFN)
+ .S TYPE=+$G(^DPT(DFN,.361)) I TYPE S TYPE=$P($G(^DIC(8,TYPE,0)),U,9) ;try PRIMARY ELIGIBILITY CODE
+ .I TYPE="" S TYPE=+$G(^DPT(DFN,"TYPE")) I TYPE S TYPE=+$G(^DG(391,TYPE,8.2)) ;try patient TYPE
+ I 'TYPE S TYPE=$G(DUZ("AG")),TYPE=$S(TYPE="V":1,1:2) ;or just assume it's HRN if not VA
+ Q $P("SSN^HRN",U,TYPE)
+ ;
+ ;
+IDCAP() ;Returns 3 characters: " ID" or "SSN"
+ I $G(DUZ("AG"))="E" Q " ID"
+ Q "SSN"
+ ;
+ ;
+ ;
+ ;
+ ;
+ ;
+LONGID ;Called by ^DIC(8.2,2,"LONG") (assumes DA(1) is DFN!)
+ N INSTITU,DFN,DFNID,SSNID,IHSID D GETALL
+ S X=$S($G(IHSID("L"))'?."-":IHSID("L"),$G(SSNID("L"))'?."-":SSNID("L"),$G(DFNID("L"))'?."-":DFNID("L"),1:"")
+ ;I X="" W 1/0  ;some LONGID must exist for a patient, else ERROR!
+ Q
+ ;
+ ;
+SHORTID ;Called by ^DIC(8.2,2,"SHORT") (assumes DA(1) is DFN!)
+ N INSTITU,DFN,DFNID,SSNID,IHSID D GETALL
+ S X=$S($G(IHSID("S"))'?."-":IHSID("S"),$G(SSNID("S"))'?."-":SSNID("S"),$G(DFNID("S"))'?."-":DFNID("S"),1:"")
+ ;I X="" W 1/0  ;some SHORTID must exist for a patient, else ERROR!
+ Q
+ ;
+ ;
+IHSID ;
+ ;given INSTITU (current institution #)
+ ;get HEALTH RECORD NUMBER (Multiple 4101, 9000001.41) associated
+ ;with the institution
+ S IHSID=$P($G(^AUPNPAT(DFN,41,+INSTITU,0)),"^",2)
+ I IHSID'="" D
+ . S IHSID("L")=IHSID ; $J(IHSID,12) ; if we want to zero pad then $TR($J(IHSID("L"),12)," ",0)
+ . S IHSID("S")=$TR(IHSID("L"),$TR(IHSID("L"),9876543210))
+ . S IHSID("S")=$TR($J(IHSID("S"),4)," ",0)
+ . S IHSID("S")=$E(IHSID("S"),$L(IHSID("S"))-3,$L(IHSID("S")))
+ ;now return Health Record Number
+ Q
+DFNID S DFN=DA(1) ; IEN in patient file, with default institution from
+ ;kernel system parameters file as prefix.
+ ;8989.3,217    DEFAULT INSTITUTION of #8989.3 -- KERNEL SYSTEM PARAMETERS FILE
+ S INSTITU=$P($G(^XTV(8989.3,1,"XUS")),U,17)
+ ;150.9  VISIT TRACKING PARAMETERS :: DEFAULT INSTITUTION:
+ I INSTITU="",$P($G(^DIC(150.9,1,0)),U,4)'="" S INSTITU=$P(^(0),U,4)
+ ; if we have a medical record number in IHS PATIENT, for this
+ I INSTITU'="",$P($G(^DIC(4,+INSTITU,99)),U)'="" S INSTITU("STA#")=$P(^(99),U)
+ ; now put INSTITUtion STATION NUMBER as prefix to DFN as "DFNID"
+ S DFNID("S")="`"_DFN,DFNID("L")=999_"-`"_DFN S:$D(INSTITU("STA#"))#2 DFNID("L")=INSTITU("STA#")_"-`"_DFN
+ Q
+SSNID ;
+ ;code scarfed from ^DIC(8.2,1,"LONG") - retrieving the SSN
+ N X
+ S SSNID("L")="" I $D(DFN),$D(^DPT(DFN,0)) S X=$P(^(0),U,9),SSNID("L")=$E(X,1,3)_"-"_$E(X,4,5)_"-"_$E(X,6,10)
+ S SSNID("S")=$P(SSNID("L"),"-",3)
+ Q
+GETALL ;
+ ;Utility Subroutine to Getall the variables
+ D DFNID,IHSID,SSNID
+ ;K DFNID,SSNID ; kill because HRN is "required"
+ Q
+ ;
+ENALL ;RE-INDEX PHONE NUMBER (KIDS POST-INSTALL DG*5.3*634)
+ K ^DPT("AZVWVOE")
+ N DIK S DIK="^DPT(",DIK(1)=".131^251000" D ENALL^DIK
+ Q
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGMSTAPI.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGMSTAPI.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGMSTAPI.m	(revision 623)
@@ -1,307 +1,307 @@
-DGMSTAPI	;ALB/SCK - API's for Military Sexual Trauma ;7:34 PM  30 Jan 2008
-	;;5.3;Registration;**195,243,308,353,379,443,700,VWEHR1**;WorldVistA 30-Jan-08;Build 4
-	;
-	;Modified from FOIA VISTA,
-	;Copyright 2008 WorldVistA.  Licensed under the terms of the GNU
-	;General Public License See attached copy of the License.
-	;
-	;This program is free software; you can redistribute it and/or modify
-	;it under the terms of the GNU General Public License as published by
-	;the Free Software Foundation; either version 2 of the License, or
-	;(at your option) any later version.
-	;
-	;This program is distributed in the hope that it will be useful,
-	;but WITHOUT ANY WARRANTY; without even the implied warranty of
-	;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-	;GNU General Public License for more details.
-	;
-	;You should have received a copy of the GNU General Public License along
-	;with this program; if not, write to the Free Software Foundation, Inc.,
-	;51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-	;
-	Q
-	;
-GETSTAT(DFN,DGDATE)	;  Retrieves the current MST status for a patient
-	;
-	;  Input
-	;    DFN  - IEN of patient in the PATIENT File (#2)
-	;    DGDATE - Date for status lookup [OPTIONAL]
-	;
-	;  Output
-	;    DGMST - Format will depend on result of lookup
-	;
-	;    If an entry is found then:
-	;       DGMST returns a 7 piece data string, caret(^)-delimited:
-	;        $P(1) = IEN of entry in MST HISTORY File (#29.11)
-	;        $P(2) = Internal value of MST Status ("Y,N,D,U")
-	;        $P(3) = Date of status change
-	;        $P(4) = IEN of provider making determination, file (#200)
-	;        $P(5) = IEN of user who entered status, file (#200)
-	;        $P(6) = External format of MST Status
-	;        $P(7) = IEN pointer of the INSTITUTION file (#4)
-	;
-	;    If no MST History is found, then:
-	;       DGMST = 0^U
-	;                "U" = (Unknown)
-	;    If an error occured in the GETS^DIQ lookup, then:
-	;       DGMST = -1^^Error Code IEN
-	;                   (returned by GETS^DIQ call)
-	;
-	; Get most recent MST status entry for the patient from file using
-	;  reverse $Order on the "APDT" x-ref.
-	;
-	N DGMST,DGIEN,DGFDA,DGMSG
-	S DFN=$G(DFN)
-	I '+DFN!('$D(^DPT(DFN,0))) D  G STATQ
-	. S DGMST="-1"
-	I '$D(^DGMS(29.11,"APDT",DFN))  D  G STATQ
-	.S DGMST="0^U"
-	S DGDATE=$S(+$G(DGDATE)>0:DGDATE,1:$$NOW^XLFDT)
-	I '$D(^DGMS(29.11,"APDT",DFN,DGDATE)) S DGDATE=$$DATE(DFN,DGDATE)
-	I '+DGDATE D  G STATQ
-	. S DGMST="0^U"
-	S DGIEN=""
-	;
-	;WV/EHR REVERSE $Q REPLACEMENT; SO 01/12/08 ;VWEHR1
-	;
-	;S DGIEN=+$P($Q(^DGMS(29.11,"APDT",DFN,DGDATE,DGIEN),-1),",",5)
-	S DGIEN=+$P($$Q^VWUTIL($NA(^DGMS(29.11,"APDT",DFN,DGDATE,DGIEN)),-1),",",5)
-	;
-	;END CHANGE
-	;
-	; Check for valid ien, if entry missing, return Unknown
-	I +DGIEN'>0 D  G STATQ
-	. S DGMST="0^U"
-	;
-	; Retrieve data
-	D GETS^DIQ(29.11,+DGIEN_",","*","IE","DGFDA","DGMSG")
-	; check for errors
-	I $D(DGMSG) D  G STATQ
-	.S DGMST="-1^^"_$G(DGMSG("DIERR",1))
-	;
-	S DGMST=DGIEN_U_$G(DGFDA(29.11,+DGIEN_",",3,"I"))_U_$G(DGFDA(29.11,+DGIEN_",",.01,"I"))_U_$G(DGFDA(29.11,+DGIEN_",",4,"I"))_U_$G(DGFDA(29.11,+DGIEN_",",5,"I"))
-	S DGMST=DGMST_U_$G(DGFDA(29.11,+DGIEN_",",3,"E"))
-	S DGMST=DGMST_U_$S($G(DGFDA(29.11,+DGIEN_",",6,"I"))]"":$G(DGFDA(29.11,+DGIEN_",",6,"I")),1:$$SITE)
-	;
-STATQ	Q $G(DGMST)
-	;
-NEWSTAT(DFN,DGSTAT,DGDATE,DGPROV,DGSITE,DGXMIT)	; MST HISTORY (#29.11) filer
-	; Callpoint to create a new MST HISTORY FILE (#29.11) entry.
-	; Will also queue HL7 message for HEC database updates.
-	;
-	;  Input
-	;    DFN    - Patients DFN
-	;    DGSTAT - MST Status code, "Y,N,D,U"
-	;    DGDATE - Date of MST status change  [default=NOW]
-	;    DGPROV - IEN of Provider making determination, file (#200)
-	;    DGSITE - IEN pointer of the INSTITUTION file (#4)
-	;    DGXMIT - HL7 transmit flag [OPTIONAL]
-	;              0=don't queue a message
-	;              1=queue a message [default])
-	;
-	;  Output
-	;    DGRSLT - Returns IEN of file (#29.11) entry if successful
-	;
-	;    If no patient was defined, then:
-	;       DGRSLT = -1^No patient defined
-	;
-	;    If an error occured in the GETS^DIQ lookup, then:
-	;       DGMST = -1^^Error Code IEN
-	;                   (returned by GETS^DIQ call)
-	;
-	N DGFDA,DGMSG,DGERR,DGRSLT,MSTIEN
-	S DFN=$G(DFN)
-	I DFN']""!('$D(^DPT(DFN,0))) D  G NEWQ
-	. S DGRSLT="-1^No patient defined"
-	;
-	S DGSTAT=$S($G(DGSTAT)]"":DGSTAT,1:"U")
-	S DGDATE=$G(DGDATE)
-	S DGPROV=$G(DGPROV)
-	S DGSITE=$G(DGSITE)
-	S DGXMIT=$S($G(DGXMIT)=0:DGXMIT,1:1)
-	S DGDATE=$S(+DGDATE>0:DGDATE,1:$$NOW^XLFDT)
-	S DGSITE=$S(+DGSITE>0:DGSITE,1:$$SITE)
-	;
-	I '$$CHANGE(DFN,DGSTAT,DGDATE) D  G NEWQ
-	. S DGRSLT="0"
-	;
-	I '$$VALID(DFN,DGSTAT,DGDATE,DGPROV,DGSITE,.DGERR) D  G NEWQ
-	. S DGRSLT="-1^"_DGERR
-	;
-	S DGFDA(1,29.11,"+1,",.01)=DGDATE
-	S DGFDA(1,29.11,"+1,",2)=DFN
-	S DGFDA(1,29.11,"+1,",3)=DGSTAT
-	S DGFDA(1,29.11,"+1,",4)=DGPROV
-	S DGFDA(1,29.11,"+1,",5)=DUZ
-	S DGFDA(1,29.11,"+1,",6)=DGSITE
-	;
-	D UPDATE^DIE("","DGFDA(1)","MSTIEN","DGERR")
-	I $D(DGERR) D  G NEWQ
-	. S DGRSLT="-1^"_$G(DGERR("DIERR",1))
-	;
-	S DGRSLT=+MSTIEN(1)
-	;
-	; Callpoint to queue an entry that will trigger a HEC
-	;  Enrollment Full Data Transmission (ORF/ORU~ZO7) HL7 message.
-	; The HL7 message will contain the following three MST data elments
-	;  as part of the VA-Specific Eligibility ZEL segment:
-	;   (23) - MST STATUS
-	;   (24) - DATE MST STATUS CHANGED
-	;   (25) - SITE DETERMINING MST STATUS
-	;
-	I DGXMIT D
-	. D SEND^DGMSTL1(DFN,"Z07")
-	;
-NEWQ	Q $G(DGRSLT)
-	;
-DELMST(MSTIEN)	; Deletes the MST HISTORY File (#29.11) entry passed in.
-	; This call is not to be used except from inside the DG MST List
-	; Manager interface.
-	;
-	; Input
-	;    MSTIEN   - IEN of the entry in the MST HISTORY File (#29.11)
-	;
-	; Output
-	;    If no IEN passed in, return -1
-	;    otherwise return 1
-	;
-	Q:'$G(MSTIEN) "-1^No entry to delete"
-	;
-	N DA,XD
-	S DA=+$G(MSTIEN)
-	S DIK="^DGMS(29.11,"
-	D ^DIK K DIK
-	Q 1
-	;
-NAME(DA)	; Returns name from the VA NEW PERSON File using DIQ call
-	;
-	N DGNAME,DGPROV,DIQ,DR,DIC
-	I $G(DA)="" G NAMEQ
-	S DIC=200,DR=".01",DIQ="DGPROV"
-	D EN^DIQ1
-	S DGNAME=$G(DGPROV(200,DA,.01))
-NAMEQ	Q $G(DGNAME)
-	;
-CHANGE(DFN,DGSTAT,DGDATE)	;Did the Status OR Date change?
-	;  Input
-	;      DFN    - Patients DFN
-	;      DGSTAT - MST Status code, "Y,N,D,U"
-	;      DGDATE - Date of MST Status Change (FM format)
-	;
-	;  Output
-	;      Returns 0 if no status change
-	;              1 if status changed
-	;
-	N DGCHG,DGMST
-	S DGCHG=0
-	I +$G(DFN)'>0!('$D(^DPT(DFN,0))) G CHNGQ
-	S DGSTAT=$G(DGSTAT)
-	I DGSTAT'?1A!("YNDU"'[DGSTAT) G CHNGQ
-	S DGDATE=$G(DGDATE)
-	I DGDATE="" G CHNGQ
-	S DGMST=$$GETSTAT(DFN),DGMST=$G(DGMST)
-	I +DGMST<1!($P(DGMST,U,2)'=$G(DGSTAT))!($P(DGMST,U,3)'=$G(DGDATE)) S DGCHG=1
-CHNGQ	Q DGCHG
-	;
-SITE(DGSITE)	;Convert a station number into a pointer to the
-	; INSTITUTION file (#4).  If called with a null parameter then
-	; the pointer to the INSTITUTION file (#4) of the primary site
-	; will be returned.
-	;
-	;  Input
-	;    DGSITE - Station number (optional)
-	;
-	;  Output
-	;    Return Site IEN to INSTITUTION file (#4)
-	;
-	S DGSITE=$G(DGSITE)
-	I DGSITE]"",$D(^DIC(4,"D",DGSITE)) D
-	. S DGSITE=$O(^DIC(4,"D",DGSITE,0))
-	E  D
-	. S DGSITE=$P($$SITE^VASITE,U)
-	I +DGSITE'>0 S DGSITE=""
-	Q DGSITE
-	;
-DATE(DFN,DGDT)	;Determine 'current' MST date
-	;
-	;  Input
-	;    DFN  - Patient's DFN
-	;    DGDT - FileMan format date
-	;
-	;  Output
-	;    Return MST effective date
-	;
-	N DGMSTDT
-	S DFN=$G(DFN)
-	I '+DFN D  G DATEQ
-	. S DGMSTDT=""
-	S DGDT=$S(+$G(DGDT)>0:DGDT,1:$$NOW^XLFDT)
-	I $P(DGDT,".",2)="" S DGDT=DGDT_".999999"
-	S DGMSTDT=$O(^DGMS(29.11,"APDT",DFN,DGDT),-1)
-DATEQ	Q DGMSTDT
-	;
-VALID(DFN,DGSTAT,DGDATE,DGPROV,DGSITE,DGERR)	;Validate fields before filing
-	; Input:
-	;      DFN - [REQUIRED] - ien of Patient
-	;   DGSTAT - [REQUIRED] - MST Status code, "Y,N,D,U"
-	;   DGDATE - [REQUIRED] - Date of MST status change[FileMan Internal]
-	;   DGPROV - [optional] - IEN of Provider making determination
-	;   DGSITE - [optional] - IEN pointer of the INSTITUTION file
-	;    DGERR - [optional] - error parameter passed by reference
-	; Output:
-	;   Function Value - Returns 1 - if validation checks passed
-	;                            0 - if validation checks failed
-	;            DGERR - an error message if validation checks fail
-	; init variables
-	N I,DGFILE,DGFLD,DGMSG,DGSTR,DGVAL,DGVAR,DGX,VALID
-	S DGFILE=29.11,VALID=1,DGMSG=" IS REQUIRED"
-	; Quit DO block if invalid condition found
-	; Check for [REQUIRED] fields
-	D
-	. I DFN="" D MSG(DGFILE,2,DGMSG,.DGERR) Q        ;pat ien
-	. I DGSTAT="" D MSG(DGFILE,3,DGMSG,.DGERR) Q     ;mst status code
-	. I DGDATE="" D MSG(DGFILE,.01,DGMSG,.DGERR) Q   ;dt chg status
-	.;
-	.; Check for valid FIELD values
-	. S DGMSG=" IS NOT VALID"
-	.; need to strip off the 'seconds' to pass the CHK^DIE() call...
-	. I DGDATE["." N DGSECS S DGSECS=$E($P(DGDATE,".",2),5,6) I DGSECS'="" I DGSECS<0!(DGSECS>60) D MSG(DGFILE,.01,DGMSG,.DGERR) Q
-	. N DGDATEX S DGDATEX=DGDATE
-	. I DGDATEX["." S DGDATEX=$P(DGDATEX,".")_"."_$E($P(DGDATEX,".",2),1,4)
-	. I $E($P(DGDATEX,".",2),1,4)="0000" S DGDATEX=$P(DGDATEX,".")_".1"
-	. S DGSTR=".01;DGDATEX^2;DFN^3;DGSTAT^4;DGPROV^5;DUZ^6;DGSITE"
-	.;
-	. F I=1:1:$L(DGSTR,U) S DGX=$P(DGSTR,U,I) Q:DGX=""  D  Q:'VALID
-	.. S DGFLD=$P(DGX,";"),DGVAR=$P(DGX,";",2),DGVAL=@DGVAR
-	.. Q:DGVAL=""
-	.. S VALID=$$TESTVAL(DGFILE,DGFLD,DGVAL)
-	.. D:'VALID MSG(DGFILE,DGFLD,DGMSG,.DGERR)
-	Q VALID
-	;
-MSG(DGFIL,DGFLD,DGMSG,DGERR)	; error message setup
-	; Input:
-	;   DGFIL - file number
-	;   DGFLD - field number of file
-	;   DGMSG - message type verbiage - " IS REQUIRED" or " IS NOT VALID"
-	;   DGERR - error parameter passed by reference
-	; Output:
-	;   DGERR - error message
-	S DGERR=$$GET1^DID(DGFIL,DGFLD,,"LABEL")_DGMSG
-	Q
-	;
-TESTVAL(DGFIL,DGFLD,DGVAL)	; Determine if a field value is valid.
-	; Input:
-	;   DGFIL - file number
-	;   DGFLD - field number of file
-	;   DGVAL - field value to be validated
-	; Output:
-	;   Function value: Returns 1 if field is valid
-	;                           0 if validation fails
-	N DGVALEX,DGRSLT,VALID
-	S VALID=1
-	I DGVAL'="" D
-	. S DGVALEX=$$EXTERNAL^DILFD(DGFIL,DGFLD,"F",DGVAL)
-	. I DGVALEX="" S VALID=0 Q   ; no external value, not valid
-	. I $$GET1^DID(DGFIL,DGFLD,"","TYPE")'="POINTER" D
-	.. D CHK^DIE(DGFIL,DGFLD,,DGVALEX,.DGRSLT) I DGRSLT="^" S VALID=0
-	Q VALID
+DGMSTAPI ;ALB/SCK - API's for Military Sexual Trauma ;7:34 PM  30 Jan 2008
+ ;;5.3;Registration;**195,243,308,353,379,443,700,VWEHR1**;WorldVistA 30-Jan-08
+ ;
+ ;Modified from FOIA VISTA,
+ ;Copyright 2008 WorldVistA.  Licensed under the terms of the GNU
+ ;General Public License See attached copy of the License.
+ ;
+ ;This program is free software; you can redistribute it and/or modify
+ ;it under the terms of the GNU General Public License as published by
+ ;the Free Software Foundation; either version 2 of the License, or
+ ;(at your option) any later version.
+ ;
+ ;This program is distributed in the hope that it will be useful,
+ ;but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ;GNU General Public License for more details.
+ ;
+ ;You should have received a copy of the GNU General Public License along
+ ;with this program; if not, write to the Free Software Foundation, Inc.,
+ ;51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ ;
+ Q
+ ;
+GETSTAT(DFN,DGDATE) ;  Retrieves the current MST status for a patient
+ ;
+ ;  Input
+ ;    DFN  - IEN of patient in the PATIENT File (#2)
+ ;    DGDATE - Date for status lookup [OPTIONAL]
+ ;
+ ;  Output
+ ;    DGMST - Format will depend on result of lookup
+ ;
+ ;    If an entry is found then:
+ ;       DGMST returns a 7 piece data string, caret(^)-delimited:
+ ;        $P(1) = IEN of entry in MST HISTORY File (#29.11)
+ ;        $P(2) = Internal value of MST Status ("Y,N,D,U")
+ ;        $P(3) = Date of status change
+ ;        $P(4) = IEN of provider making determination, file (#200)
+ ;        $P(5) = IEN of user who entered status, file (#200)
+ ;        $P(6) = External format of MST Status
+ ;        $P(7) = IEN pointer of the INSTITUTION file (#4)
+ ;
+ ;    If no MST History is found, then:
+ ;       DGMST = 0^U
+ ;                "U" = (Unknown)
+ ;    If an error occured in the GETS^DIQ lookup, then:
+ ;       DGMST = -1^^Error Code IEN
+ ;                   (returned by GETS^DIQ call)
+ ;
+ ; Get most recent MST status entry for the patient from file using
+ ;  reverse $Order on the "APDT" x-ref.
+ ;
+ N DGMST,DGIEN,DGFDA,DGMSG
+ S DFN=$G(DFN)
+ I '+DFN!('$D(^DPT(DFN,0))) D  G STATQ
+ . S DGMST="-1"
+ I '$D(^DGMS(29.11,"APDT",DFN))  D  G STATQ
+ .S DGMST="0^U"
+ S DGDATE=$S(+$G(DGDATE)>0:DGDATE,1:$$NOW^XLFDT)
+ I '$D(^DGMS(29.11,"APDT",DFN,DGDATE)) S DGDATE=$$DATE(DFN,DGDATE)
+ I '+DGDATE D  G STATQ
+ . S DGMST="0^U"
+ S DGIEN=""
+ ;
+ ;WV/EHR REVERSE $Q REPLACEMENT; SO 01/12/08 ;VWEHR1
+ ;
+ ;S DGIEN=+$P($Q(^DGMS(29.11,"APDT",DFN,DGDATE,DGIEN),-1),",",5)
+ S DGIEN=+$P($$Q^VWUTIL($NA(^DGMS(29.11,"APDT",DFN,DGDATE,DGIEN)),-1),",",5)
+ ;
+ ;END CHANGE
+ ;
+ ; Check for valid ien, if entry missing, return Unknown
+ I +DGIEN'>0 D  G STATQ
+ . S DGMST="0^U"
+ ;
+ ; Retrieve data
+ D GETS^DIQ(29.11,+DGIEN_",","*","IE","DGFDA","DGMSG")
+ ; check for errors
+ I $D(DGMSG) D  G STATQ
+ .S DGMST="-1^^"_$G(DGMSG("DIERR",1))
+ ;
+ S DGMST=DGIEN_U_$G(DGFDA(29.11,+DGIEN_",",3,"I"))_U_$G(DGFDA(29.11,+DGIEN_",",.01,"I"))_U_$G(DGFDA(29.11,+DGIEN_",",4,"I"))_U_$G(DGFDA(29.11,+DGIEN_",",5,"I"))
+ S DGMST=DGMST_U_$G(DGFDA(29.11,+DGIEN_",",3,"E"))
+ S DGMST=DGMST_U_$S($G(DGFDA(29.11,+DGIEN_",",6,"I"))]"":$G(DGFDA(29.11,+DGIEN_",",6,"I")),1:$$SITE)
+ ;
+STATQ Q $G(DGMST)
+ ;
+NEWSTAT(DFN,DGSTAT,DGDATE,DGPROV,DGSITE,DGXMIT) ; MST HISTORY (#29.11) filer
+ ; Callpoint to create a new MST HISTORY FILE (#29.11) entry.
+ ; Will also queue HL7 message for HEC database updates.
+ ;
+ ;  Input
+ ;    DFN    - Patients DFN
+ ;    DGSTAT - MST Status code, "Y,N,D,U"
+ ;    DGDATE - Date of MST status change  [default=NOW]
+ ;    DGPROV - IEN of Provider making determination, file (#200)
+ ;    DGSITE - IEN pointer of the INSTITUTION file (#4)
+ ;    DGXMIT - HL7 transmit flag [OPTIONAL]
+ ;              0=don't queue a message
+ ;              1=queue a message [default])
+ ;
+ ;  Output
+ ;    DGRSLT - Returns IEN of file (#29.11) entry if successful
+ ;
+ ;    If no patient was defined, then:
+ ;       DGRSLT = -1^No patient defined
+ ;
+ ;    If an error occured in the GETS^DIQ lookup, then:
+ ;       DGMST = -1^^Error Code IEN
+ ;                   (returned by GETS^DIQ call)
+ ;
+ N DGFDA,DGMSG,DGERR,DGRSLT,MSTIEN
+ S DFN=$G(DFN)
+ I DFN']""!('$D(^DPT(DFN,0))) D  G NEWQ
+ . S DGRSLT="-1^No patient defined"
+ ;
+ S DGSTAT=$S($G(DGSTAT)]"":DGSTAT,1:"U")
+ S DGDATE=$G(DGDATE)
+ S DGPROV=$G(DGPROV)
+ S DGSITE=$G(DGSITE)
+ S DGXMIT=$S($G(DGXMIT)=0:DGXMIT,1:1)
+ S DGDATE=$S(+DGDATE>0:DGDATE,1:$$NOW^XLFDT)
+ S DGSITE=$S(+DGSITE>0:DGSITE,1:$$SITE)
+ ;
+ I '$$CHANGE(DFN,DGSTAT,DGDATE) D  G NEWQ
+ . S DGRSLT="0"
+ ;
+ I '$$VALID(DFN,DGSTAT,DGDATE,DGPROV,DGSITE,.DGERR) D  G NEWQ
+ . S DGRSLT="-1^"_DGERR
+ ;
+ S DGFDA(1,29.11,"+1,",.01)=DGDATE
+ S DGFDA(1,29.11,"+1,",2)=DFN
+ S DGFDA(1,29.11,"+1,",3)=DGSTAT
+ S DGFDA(1,29.11,"+1,",4)=DGPROV
+ S DGFDA(1,29.11,"+1,",5)=DUZ
+ S DGFDA(1,29.11,"+1,",6)=DGSITE
+ ;
+ D UPDATE^DIE("","DGFDA(1)","MSTIEN","DGERR")
+ I $D(DGERR) D  G NEWQ
+ . S DGRSLT="-1^"_$G(DGERR("DIERR",1))
+ ;
+ S DGRSLT=+MSTIEN(1)
+ ;
+ ; Callpoint to queue an entry that will trigger a HEC
+ ;  Enrollment Full Data Transmission (ORF/ORU~ZO7) HL7 message.
+ ; The HL7 message will contain the following three MST data elments
+ ;  as part of the VA-Specific Eligibility ZEL segment:
+ ;   (23) - MST STATUS
+ ;   (24) - DATE MST STATUS CHANGED
+ ;   (25) - SITE DETERMINING MST STATUS
+ ;
+ I DGXMIT D
+ . D SEND^DGMSTL1(DFN,"Z07")
+ ;
+NEWQ Q $G(DGRSLT)
+ ;
+DELMST(MSTIEN) ; Deletes the MST HISTORY File (#29.11) entry passed in.
+ ; This call is not to be used except from inside the DG MST List
+ ; Manager interface.
+ ;
+ ; Input
+ ;    MSTIEN   - IEN of the entry in the MST HISTORY File (#29.11)
+ ;
+ ; Output
+ ;    If no IEN passed in, return -1
+ ;    otherwise return 1
+ ;
+ Q:'$G(MSTIEN) "-1^No entry to delete"
+ ;
+ N DA,XD
+ S DA=+$G(MSTIEN)
+ S DIK="^DGMS(29.11,"
+ D ^DIK K DIK
+ Q 1
+ ;
+NAME(DA) ; Returns name from the VA NEW PERSON File using DIQ call
+ ;
+ N DGNAME,DGPROV,DIQ,DR,DIC
+ I $G(DA)="" G NAMEQ
+ S DIC=200,DR=".01",DIQ="DGPROV"
+ D EN^DIQ1
+ S DGNAME=$G(DGPROV(200,DA,.01))
+NAMEQ Q $G(DGNAME)
+ ;
+CHANGE(DFN,DGSTAT,DGDATE) ;Did the Status OR Date change?
+ ;  Input
+ ;      DFN    - Patients DFN
+ ;      DGSTAT - MST Status code, "Y,N,D,U"
+ ;      DGDATE - Date of MST Status Change (FM format)
+ ;
+ ;  Output
+ ;      Returns 0 if no status change
+ ;              1 if status changed
+ ;
+ N DGCHG,DGMST
+ S DGCHG=0
+ I +$G(DFN)'>0!('$D(^DPT(DFN,0))) G CHNGQ
+ S DGSTAT=$G(DGSTAT)
+ I DGSTAT'?1A!("YNDU"'[DGSTAT) G CHNGQ
+ S DGDATE=$G(DGDATE)
+ I DGDATE="" G CHNGQ
+ S DGMST=$$GETSTAT(DFN),DGMST=$G(DGMST)
+ I +DGMST<1!($P(DGMST,U,2)'=$G(DGSTAT))!($P(DGMST,U,3)'=$G(DGDATE)) S DGCHG=1
+CHNGQ Q DGCHG
+ ;
+SITE(DGSITE) ;Convert a station number into a pointer to the
+ ; INSTITUTION file (#4).  If called with a null parameter then
+ ; the pointer to the INSTITUTION file (#4) of the primary site
+ ; will be returned.
+ ;
+ ;  Input
+ ;    DGSITE - Station number (optional)
+ ;
+ ;  Output
+ ;    Return Site IEN to INSTITUTION file (#4)
+ ;
+ S DGSITE=$G(DGSITE)
+ I DGSITE]"",$D(^DIC(4,"D",DGSITE)) D
+ . S DGSITE=$O(^DIC(4,"D",DGSITE,0))
+ E  D
+ . S DGSITE=$P($$SITE^VASITE,U)
+ I +DGSITE'>0 S DGSITE=""
+ Q DGSITE
+ ;
+DATE(DFN,DGDT) ;Determine 'current' MST date
+ ;
+ ;  Input
+ ;    DFN  - Patient's DFN
+ ;    DGDT - FileMan format date
+ ;
+ ;  Output
+ ;    Return MST effective date
+ ;
+ N DGMSTDT
+ S DFN=$G(DFN)
+ I '+DFN D  G DATEQ
+ . S DGMSTDT=""
+ S DGDT=$S(+$G(DGDT)>0:DGDT,1:$$NOW^XLFDT)
+ I $P(DGDT,".",2)="" S DGDT=DGDT_".999999"
+ S DGMSTDT=$O(^DGMS(29.11,"APDT",DFN,DGDT),-1)
+DATEQ Q DGMSTDT
+ ;
+VALID(DFN,DGSTAT,DGDATE,DGPROV,DGSITE,DGERR) ;Validate fields before filing
+ ; Input:
+ ;      DFN - [REQUIRED] - ien of Patient
+ ;   DGSTAT - [REQUIRED] - MST Status code, "Y,N,D,U"
+ ;   DGDATE - [REQUIRED] - Date of MST status change[FileMan Internal]
+ ;   DGPROV - [optional] - IEN of Provider making determination
+ ;   DGSITE - [optional] - IEN pointer of the INSTITUTION file
+ ;    DGERR - [optional] - error parameter passed by reference
+ ; Output:
+ ;   Function Value - Returns 1 - if validation checks passed
+ ;                            0 - if validation checks failed
+ ;            DGERR - an error message if validation checks fail
+ ; init variables
+ N I,DGFILE,DGFLD,DGMSG,DGSTR,DGVAL,DGVAR,DGX,VALID
+ S DGFILE=29.11,VALID=1,DGMSG=" IS REQUIRED"
+ ; Quit DO block if invalid condition found
+ ; Check for [REQUIRED] fields
+ D
+ . I DFN="" D MSG(DGFILE,2,DGMSG,.DGERR) Q        ;pat ien
+ . I DGSTAT="" D MSG(DGFILE,3,DGMSG,.DGERR) Q     ;mst status code
+ . I DGDATE="" D MSG(DGFILE,.01,DGMSG,.DGERR) Q   ;dt chg status
+ .;
+ .; Check for valid FIELD values
+ . S DGMSG=" IS NOT VALID"
+ .; need to strip off the 'seconds' to pass the CHK^DIE() call...
+ . I DGDATE["." N DGSECS S DGSECS=$E($P(DGDATE,".",2),5,6) I DGSECS'="" I DGSECS<0!(DGSECS>60) D MSG(DGFILE,.01,DGMSG,.DGERR) Q
+ . N DGDATEX S DGDATEX=DGDATE
+ . I DGDATEX["." S DGDATEX=$P(DGDATEX,".")_"."_$E($P(DGDATEX,".",2),1,4)
+ . I $E($P(DGDATEX,".",2),1,4)="0000" S DGDATEX=$P(DGDATEX,".")_".1"
+ . S DGSTR=".01;DGDATEX^2;DFN^3;DGSTAT^4;DGPROV^5;DUZ^6;DGSITE"
+ .;
+ . F I=1:1:$L(DGSTR,U) S DGX=$P(DGSTR,U,I) Q:DGX=""  D  Q:'VALID
+ .. S DGFLD=$P(DGX,";"),DGVAR=$P(DGX,";",2),DGVAL=@DGVAR
+ .. Q:DGVAL=""
+ .. S VALID=$$TESTVAL(DGFILE,DGFLD,DGVAL)
+ .. D:'VALID MSG(DGFILE,DGFLD,DGMSG,.DGERR)
+ Q VALID
+ ;
+MSG(DGFIL,DGFLD,DGMSG,DGERR) ; error message setup
+ ; Input:
+ ;   DGFIL - file number
+ ;   DGFLD - field number of file
+ ;   DGMSG - message type verbiage - " IS REQUIRED" or " IS NOT VALID"
+ ;   DGERR - error parameter passed by reference
+ ; Output:
+ ;   DGERR - error message
+ S DGERR=$$GET1^DID(DGFIL,DGFLD,,"LABEL")_DGMSG
+ Q
+ ;
+TESTVAL(DGFIL,DGFLD,DGVAL) ; Determine if a field value is valid.
+ ; Input:
+ ;   DGFIL - file number
+ ;   DGFLD - field number of file
+ ;   DGVAL - field value to be validated
+ ; Output:
+ ;   Function value: Returns 1 if field is valid
+ ;                           0 if validation fails
+ N DGVALEX,DGRSLT,VALID
+ S VALID=1
+ I DGVAL'="" D
+ . S DGVALEX=$$EXTERNAL^DILFD(DGFIL,DGFLD,"F",DGVAL)
+ . I DGVALEX="" S VALID=0 Q   ; no external value, not valid
+ . I $$GET1^DID(DGFIL,DGFLD,"","TYPE")'="POINTER" D
+ .. D CHK^DIE(DGFIL,DGFLD,,DGVALEX,.DGRSLT) I DGRSLT="^" S VALID=0
+ Q VALID
